<template>
  <q-page class="flex">
    <div class="doc-container col-12 tags">
      <div class="minheight-rows gutter-xs">

          <div class="row title-row items-center">
              <i class="fas fa-tags"></i>
              <div class="page-title">{{ $t('Thesaurus')}}</div>
          </div>

          <div class="row justify-center">
              <div class="col-6">
                  <q-search v-model="searchedTerm"
                            inverted
                            id="tag-search"
                  />
              </div>
          </div>

          <div class="row justify-center margin-top-20">
              <div class="col-6">
                <div class="row justify-center items-center">
                  <span>{{ $t('Cant_find')}}</span>
                </div>
                <div class="row justify-center items-center">
                    <q-btn
                            icon="add"
                            :label="$t('tag.add')"
                            @click="addTerm"
                            class="action-btn"
                            rounded
                            :disable="!searchedTerm"
                    />
                </div>
              </div>
          </div>

          <div class="row justify-center margin-top-20">
            <q-chip class="tag"
                    :closable="item.custom"
                    v-for="(item, index) in filteredItems"
                    :key="index"
                    @hide="delTerm(item)"
            >
                {{item.term}}
            </q-chip>
          </div>

      </div>
    </div>
  </q-page>
</template>

<script>
import {mapActions, mapState} from 'vuex'

export default {
  name: 'Users',
  data: () => ({
    searchedTerm: '',
    columns: [
      {
        name: 'term',
        label: 'Term',
        required: true,
        visible: false
      },
      {
        name: 'commands',
        label: '',
        required: true,
        sortable: false
      }
    ]
  }),
  methods: {
    ...mapActions('categories', [
      'listTerms',
      'createTerm',
      'deleteTerm'
    ]),

    addTerm () {
      this.createTerm({term: this.searchedTerm})
    },

    delTerm (item) {
      this.$q.dialog({
        title: this.$t('tag.Delete'),
        message: this.$t('tag.delete_confirm'),
        ok: this.$t('state.Delete'),
        cancel: this.$t('Cancel')
      }).then(() => {
        this.$q.notify({
          message: this.$t('state.Deleted'),
          timeout: 3000,
          type: 'positive',
          icon: 'delete',
          detail: this.$t('tag.delete_confirmation'),
          position: 'top-right'
        })
        this.deleteTerm({ term: item.term })
      })
    }
  },
  computed: {
    filteredItems: function () {
      if (!this.searchedTerm) {
        return this.terms
      }
      return this.terms.filter(word => word.term.toLowerCase().includes(this.searchedTerm.toLowerCase()))
    },
    ...mapState('categories', {terms: (state) => state.terms})
  },
  mounted: function () {
    this.listTerms()
  }
}
</script>
